//-----------------------------------------------------------------------------
//Api_2_Ues_Gthd_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ues_gthd;

import uicc.usim.test.util.*;
import uicc.usim.toolkit.*;
/**
* Test Area : uicc.usim.tookit.USATEnvelopeHandler.getTheHandler()
* 
* Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
*
* @version 0.0.1 - 28/07/00
*
*/
public class Api_2_Ues_Gthd_1  extends  TestToolkitApplet implements uicc.usim.toolkit.ToolkitConstants
{

    /** Registry entry concerning applet instance */
    //private ToolkitRegistry obReg;
    
    private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};
    
    private static USATEnvelopeHandler envHdlr3;
    private USATEnvelopeHandler envHdlr4;
    
    // Number of tests
    byte testCaseNb = (byte) 0x00;
    byte testCaseSubNb =(byte) 0x01;
      
    /**
    * Constructor of the applet
    */
    public Api_2_Ues_Gthd_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
          Api_2_Ues_Gthd_1  thisApplet = new Api_2_Ues_Gthd_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();
        //register to EVENT_FORMATTED_SMS_PP_ENV
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
          //ProactiveHandler proHdlr = ProactiveHandlerSystem.getTheHandler() ;
        
        switch ( testCaseNb ) 
        {
            case (byte) 0 :
                // --------------------------------------------
                // Test Case 1 : use th methode getTheHandler() Twice 
                testCaseNb = (byte) 1 ;
    
                bRes = false ;
                try {
                    USATEnvelopeHandler envHdlr1 = USATEnvelopeHandlerSystem.getTheHandler();
                    USATEnvelopeHandler envHdlr2 = USATEnvelopeHandlerSystem.getTheHandler();
      
                    if (envHdlr1==envHdlr2 )
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 1 :
                // --------------------------------------------
                // Test Case 2 : verify that the methode getTheHandler return EnvelopeHandler reference
                testCaseNb = (byte) 2 ;
    
                bRes = false ;
                try {
                    USATEnvelopeHandler envHdlr1 = USATEnvelopeHandlerSystem.getTheHandler();
                    
                    if (envHdlr1 instanceof USATEnvelopeHandler)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
    
            case (byte) 2 :
                // --------------------------------------------
                // Test Case 3 : verify that the methode getTheHandler does not return NULL
                testCaseNb = (byte) 3 ;
    
                bRes = false ;
                try {
                    USATEnvelopeHandler envHdlr1 = USATEnvelopeHandlerSystem.getTheHandler();
                    
                    if (envHdlr1!=null)
                        bRes = true;
                }
                catch (Exception e)    {    
                    bRes = false ;
                }
                reportTestOutcome(testCaseNb, bRes) ;
                break;
        }
    }
}
