//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_api_hepo;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import uicc.usim.toolkit.*;
import uicc.usim.test.util.*;


/**
 * Usat Framework, Others parts transferred from API, a Handler is JCRE temporary entry point object
 * applet 1
 */
public class Ufw_Api_Hepo_1 extends TestToolkitApplet {

    private byte testCaseNb = (byte)0x00;
    private static boolean bRes;

    /** Registry entry concerning applet instance */
    private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

    static Object staticObject;
    Object object;

    // Constructor of the applet
    public Ufw_Api_Hepo_1() {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) {

        // Create a new applet instance
        Ufw_Api_Hepo_1 thisApplet = new Ufw_Api_Hepo_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();

        // Register to EVENT_UNRECOGNIZED_ENVELOPE
        thisApplet.obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);

    }

    /**
     *  Method called by the CAT RE
     */
    public void processToolkit(short event) {

        /** Test Case 1: USATEnvelopeHandler with static field */
        testCaseNb = (byte)1;

        bRes = false ;
        try {
            staticObject = USATEnvelopeHandlerSystem.getTheHandler();
        }
        catch (SecurityException e) {
            bRes = true;
        }
        catch (Exception e) {
        }
        reportTestOutcome(testCaseNb, bRes);

        /** Test Case 2: USATEnvelopeHandler with field */
        testCaseNb = (byte)2;

        bRes = false ;
        try {
            object = USATEnvelopeHandlerSystem.getTheHandler();
        }
        catch (SecurityException e) {
            bRes = true;
        }
        catch (Exception e) {
        }
        reportTestOutcome(testCaseNb, bRes);

    }
}
