//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//----------------------------------------------------------------------------- 
package uicc.usim.test.usatframework.ufw_mha_uehd;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.toolkit.*;
import uicc.usim.test.util.* ;


public class Ufw_Mha_Uehd_2 extends TestToolkitApplet {
    /** result of specific testcase */
    boolean         bRes    = false;
    /** number of testcase */
    byte          testCaseNb  = (byte) 0x00;
    private final short     eventList[] = { 
                        EVENT_UNFORMATTED_SMS_PP_ENV,
                        EVENT_UNFORMATTED_SMS_CB,
                        EVENT_UNFORMATTED_SMS_PP_UPD};  
    
    /**
     */
    private Ufw_Mha_Uehd_2 () {
  
    }
  
    public static void install(byte[] bArray, short bOffset, byte bLength) {
 
         
        // Create a new applet instance.
        Ufw_Mha_Uehd_2 thisApplet = new Ufw_Mha_Uehd_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
              
        //- Applet registration     
        thisApplet.obReg.setEventList(thisApplet.eventList,(short)0,(short)(thisApplet.eventList.length));
    }
    
  
    public void processToolkit(short event) throws ToolkitException {
              
        switch(event){
  
            case EVENT_UNFORMATTED_SMS_PP_ENV:
                
                testCaseNb=(byte)0x01;
                getUSATEnvelopeHandler(testCaseNb);
                
                break;

            case EVENT_UNFORMATTED_SMS_PP_UPD:
                
                testCaseNb=(byte)0x02;
                getUSATEnvelopeHandler(testCaseNb);
                
                break;
                   
            case EVENT_UNFORMATTED_SMS_CB:
                
                testCaseNb=(byte)0x03;
                getUSATEnvelopeHandler(testCaseNb);
                
                break;              
    }
  }

    /**
     * Method test if a instance of the USATEnvelopeHandler class can be 
     * successful instantiated. If so the test case will be reported as
     * successful. Otherwise as failure.
     * 
     * @param testCaseNb number of the current test case
     */ 
    private void getUSATEnvelopeHandler(byte testCaseNb) {
      bRes=false;
      try {
        //get the USAT Envelope Handler
        USATEnvelopeHandler uenHdr = USATEnvelopeHandlerSystem.getTheHandler();
        bRes=true;
      }
      catch(Exception exp) {
        bRes=false;
      }
      this.reportTestOutcome(testCaseNb,bRes);
    }
  
  

}