//-----------------------------------------------------------------------------
//Ufw_Erp_Emcn_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_erp_emcn;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import uicc.usim.test.util.*;
import uicc.toolkit.*;
import uicc.usim.toolkit.*;

/**
* Test Area : uicc.usim.usatframework.ufw_erp_emcn
*/
public class Ufw_Erp_Emcn_1  extends TestToolkitApplet implements uicc.usim.toolkit.ToolkitConstants
{
    
    private static final byte[] DATA2POST = {(byte)0x91, (byte)0x11, (byte)0x22, (byte)0x33, (byte)0x44} ;

    /**
    * Constructor of the applet
    */
    public Ufw_Erp_Emcn_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Ufw_Erp_Emcn_1  thisApplet = new Ufw_Erp_Emcn_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init();    
        
        // Registration to EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM
        thisApplet.obReg.setEvent(EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM);
    }
    
    
    /**
     * Method called by the USAT Framework
    */
    public void processToolkit(short event) 
    {
        // Result of each test
        boolean bRes = false;

        // Get the system instance of the EnvelopeHandler class
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();

        // Get the system instance of the EnvelopeResponseHandler class
        EnvelopeResponseHandler envRespHandler = EnvelopeResponseHandlerSystem.getTheHandler();

        // EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM :
        // --------------------------------------------
        // The applet changes any incoming TP_Destination_Address and any RP_Destination_Address
        // of the Service Center into + 11 22 33 44
        try 
        {
            bRes = false;
            envRespHandler.appendTLV((byte)(TAG_ADDRESS | TAG_SET_CR), DATA2POST, (short)0x00, (short)DATA2POST.length);
            envRespHandler.appendTLV((byte)(TAG_ADDRESS | TAG_SET_CR), DATA2POST, (short)0x00, (short)DATA2POST.length);
            envRespHandler.postAsBERTLV(true, (byte)0x02);
            bRes = true;
        }
        catch (Exception e)
        {
            bRes = false;
        }
        reportTestOutcome((byte)1, bRes);
    }
}
